///home/berryj/link/bin/genMethods "-g" "-t" "AttributeBase*" "-h" "Collection" "-I" "LINK/basic/SetFuncs.h" "-I" "LINK/basic/Collection.h" "-I" "LINK/graph/Attribute.h" "-d" "graph" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/basic/SetFuncs.h>

#include <LINK/basic/Collection.h>

#include <LINK/graph/Attribute.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>
#include <LINK/stkWrapper/CollectionWrapper.h>


typedef AttributeBase* _AttributeBase_;
typedef Collection<AttributeBase* > _Collection_AttributeBase__;

#define _Collection_AttributeBase__DATA(x) ((Collection<AttributeBase* >*) (EXTDATA(x)))
#define _Collection_AttributeBase__IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Collection<AttributeBase* > >::type))
#define _Collection_AttributeBase__ISNT_DATA(x) (!_Collection_AttributeBase__IS_DATA(x))

#define _Collection_AttributeBase__CXX_DATA(x) (*(Collection<AttributeBase* >*) (EXTDATA(VAL(x))))
#define _Collection_AttributeBase__CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Collection<AttributeBase* > >::type))
#define _Collection_AttributeBase__CXX_ISNT_DATA(x) (!_Collection_AttributeBase__CXX_IS_DATA(x))


PRIMITIVE STk_init__Collection_AttributeBase__()
{
	Wrapper<_Collection_AttributeBase__>::type = STk_new_CXXwrapper_id(
			Wrapper<_Collection_AttributeBase__>::name, 
			"",
			(void (*)(SCM x, SCM port, int mode))
			CollectionWrapper<_AttributeBase_>::displayTypedCollection,
			(void (*)(SCM x))CollectionWrapper<_AttributeBase_>::markTypedCollection,
			(void (*)(SCM x))CollectionWrapper<_AttributeBase_>::freeTypedCollection);
	Tcl_InitHashTable(&Register<_Collection_AttributeBase__>::objTable, TCL_ONE_WORD_KEYS);
	return UNDEFINED;
}

void genExtra_Collection_AttributeBase__Methods(void);

PRIMITIVE STk_init_methods__Collection_AttributeBase__()
{
	STk_add_new_cpp_primitive("collection-AttributeBase?", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_AttributeBase_>::collectionP);
	STk_add_new_cpp_primitive("mset-AttributeBase1", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_AttributeBase_>::buildMSet);
	STk_add_new_cpp_primitive("set-AttributeBase1", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_AttributeBase_>::buildSet);
	STk_add_new_cpp_primitive("sequence-AttributeBase1", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_AttributeBase_>::buildSequence);
	STk_add_new_cpp_primitive("Collection-AttributeBase-sorted?", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_AttributeBase_>::sortedLinkCollection);
	STk_add_new_cpp_primitive("Collection-AttributeBase-size", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_AttributeBase_>::sizeLinkCollection);
	STk_add_new_cpp_primitive("Collection-AttributeBase-null?", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_AttributeBase_>::nullLinkCollection);
	STk_add_new_cpp_primitive("Collection-AttributeBase-eqv?", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_AttributeBase_>::eqvLinkCollection);
	STk_add_new_cpp_primitive("Collection-AttributeBase-<", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_AttributeBase_>::lthLinkCollection);
	STk_add_new_cpp_primitive("Collection-AttributeBase-<=", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_AttributeBase_>::leLinkCollection);
	STk_add_new_cpp_primitive("Collection-AttributeBase->", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_AttributeBase_>::grLinkCollection);
	STk_add_new_cpp_primitive("Collection-AttributeBase->=", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_AttributeBase_>::geLinkCollection);
	STk_add_new_cpp_primitive("Collection-AttributeBase-member", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_AttributeBase_>::memberLinkCollection);
	STk_add_new_cpp_primitive("Collection-AttributeBase-clear!", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_AttributeBase_>::clearLinkCollection);
	STk_add_new_cpp_primitive("Collection-AttributeBase-insert!", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_AttributeBase_>::insertLinkCollection);
	STk_add_new_cpp_primitive("Collection-AttributeBase-append!", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_AttributeBase_>::appendLinkCollection);
	STk_add_new_cpp_primitive("Collection-AttributeBase-remove!", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_AttributeBase_>::removeLinkCollection);
	STk_add_new_cpp_primitive("Collection-AttributeBase-occurrences", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_AttributeBase_>::occurrencesLinkCollection);
	STk_add_new_cpp_primitive("Collection-AttributeBase-ref", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_AttributeBase_>::refLinkCollection);
	STk_add_new_cpp_primitive("Collection-AttributeBase-rank", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_AttributeBase_>::rankLinkCollection);
	STk_add_new_cpp_primitive("Collection-AttributeBase-+", tc_subr_1_or_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_AttributeBase_>::unionLinkCollection);
	STk_add_new_cpp_primitive("Collection-AttributeBase-^", tc_subr_1_or_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_AttributeBase_>::intersectionLinkCollection);
	STk_add_new_cpp_primitive("Collection-AttributeBase--", tc_subr_1_or_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_AttributeBase_>::differenceLinkCollection);
	STk_add_new_cpp_primitive("Collection-AttributeBase-subset", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_AttributeBase_>::subsetLinkCollection);
	STk_add_new_cpp_primitive("Collection-AttributeBase-proper-subset", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_AttributeBase_>::properSubsetLinkCollection);
	STk_add_new_cpp_primitive("list->mset-AttributeBase", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_AttributeBase_>::stkList2LinkMSet);
	STk_add_new_cpp_primitive("list->set-AttributeBase", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_AttributeBase_>::stkList2LinkSet);
	STk_add_new_cpp_primitive("list->sequence-AttributeBase", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_AttributeBase_>::stkList2LinkSequence);
	STk_add_new_cpp_primitive("mset-AttributeBase->list", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_AttributeBase_>::collection2STkList);
	STk_add_new_cpp_primitive("set-AttributeBase->list", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_AttributeBase_>::collection2STkList);
	STk_add_new_cpp_primitive("sequence-AttributeBase->list", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_AttributeBase_>::collection2STkList);
	STk_add_new_cpp_primitive("mset-AttributeBase->string", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_AttributeBase_>::collection2STkString);
	STk_add_new_cpp_primitive("set-AttributeBase->string", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_AttributeBase_>::collection2STkString);
	STk_add_new_cpp_primitive("sequence-AttributeBase->string", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_AttributeBase_>::collection2STkString);

	addListMethod("mset-AttributeBase",
		"mset-AttributeBase1", LINK_NEW);
	addListMethod("set-AttributeBase",
		"set-AttributeBase1", LINK_NEW);
	addListMethod("sequence-AttributeBase",
		"sequence-AttributeBase1", LINK_NEW);
	addOneArgMethod("null?",
		Wrapper<_Collection_AttributeBase__ >::name, 
		"Collection-AttributeBase-null?", LINK_OVL);
	addOneArgMethod("size",
		Wrapper<_Collection_AttributeBase__ >::name, 
		"Collection-AttributeBase-size", LINK_NEW);
	addTwoArgMethod("eqv?",
		Wrapper<_Collection_AttributeBase__ >::name, 
		Wrapper<_Collection_AttributeBase__ >::name, 
		"Collection-AttributeBase-eqv?", LINK_OVL);
	addBooleanMethod("<",
		Wrapper<_Collection_AttributeBase__ >::name, 
		"Collection-AttributeBase-<", LINK_OVL);
	addBooleanMethod("<=",
		Wrapper<_Collection_AttributeBase__ >::name, 
		"Collection-AttributeBase-<=", LINK_OVL);
	addBooleanMethod(">",
		Wrapper<_Collection_AttributeBase__ >::name, 
		"Collection-AttributeBase->", LINK_OVL);
	addBooleanMethod(">=",
		Wrapper<_Collection_AttributeBase__ >::name, 
		"Collection-AttributeBase->=", LINK_OVL);
	addTwoArgMethod("member",
		Wrapper<_AttributeBase_ >::name, 
		Wrapper<_Collection_AttributeBase__ >::name, 
		"Collection-AttributeBase-member", LINK_OVL);
	addTwoArgMethod("ref",
		Wrapper<_Collection_AttributeBase__ >::name, 
		"<integer>",
		"Collection-AttributeBase-ref", LINK_NEW);
	addOneArgMethod("clear!",
		Wrapper<_Collection_AttributeBase__ >::name, 
		"Collection-AttributeBase-clear!", LINK_NEW);
	addTwoArgMethod("insert!",
		Wrapper<_AttributeBase_ >::name, 
		Wrapper<_Collection_AttributeBase__ >::name, 
		"Collection-AttributeBase-insert!", LINK_NEW);
	addTwoArgMethod("append!",
		Wrapper<_AttributeBase_ >::name, 
		Wrapper<_Collection_AttributeBase__ >::name, 
		"Collection-AttributeBase-append!", LINK_NEW);
	addTwoArgMethod("remove!",
		Wrapper<_AttributeBase_ >::name, 
		Wrapper<_Collection_AttributeBase__ >::name, 
		"Collection-AttributeBase-remove!", LINK_NEW);
	addArbMethod("+",
		Wrapper<_Collection_AttributeBase__ >::name, 
		"Collection-AttributeBase-+", LINK_OVL);
	addArbMethod("^",
		Wrapper<_Collection_AttributeBase__ >::name, 
		"Collection-AttributeBase-^", LINK_NEW);
	addArbMethod("-",
		Wrapper<_Collection_AttributeBase__ >::name, 
		"Collection-AttributeBase--", LINK_OVL);
	genExtra_Collection_AttributeBase__Methods();
	return UNDEFINED;
}
